<template>
  <div
    ref="component"
    class="TabSimple">
    <div class="TopHeading">
      <el-input
        :placeholder="'search ' + singleItem"
        :clearable="true"
        v-model="filter"
        @input="onFilterItems"
        @keyup.down.native="keyDown"
        @keyup.up.native="keyUp"
        @keyup.enter.native="keyEnter"
        ref="search"
        prefix-icon="el-icon-search">
      </el-input>
      <div class="_buttons">
        <slot name="extra-buttons"></slot>
        <el-button
          :type="creatable ? 'success' : '' "
          @click="$emit('create')"
          :icon="creatable ? 'el-icon-plus' : ''">
          {{ items.length }}
        </el-button>
      </div>
    </div>
    <virtual-list
      v-if="filteredItems.length"
      class="_list"
      ref="virtualList"
      :start="listItemStart"
      :size="50"
      :remain="20">
      <div
        class="_item"
        v-for="(item, index) in filteredItems"
        :class="{'-sel': index === selectedIndex}"
        :key="index">
        <span
          class="name"
          @click="$emit('leftClick', item)"
          @click.right.prevent="$emit('rightClick', item)"
          @click.middle.prevent="$emit('middleClick', item)"
          :title="itemTitle || item[keyTitle]">
          <slot name="icon" :item="item"></slot>
          {{ item.name }}
        </span>
        <div class="_controls">
          <slot name="controls" :item="item"></slot>
        </div>
        <div class="_slider">
          <slot name="slider" :item="item"></slot>
        </div>
      </div>
    </virtual-list>
    <div
      v-else
      class="empty">
        <h1>No items</h1>
    </div>
  </div>
</template>

<script>
import virtualList from 'vue-virtual-scroll-list'

export default {
  components: {
    virtualList,
  },
  props: {
    value: {
      default: () => ([])
    },
    tabName: {
      default: '',
      type: String,
    },
    singleItem: {
      default: '',
      type: String,
    },
    isTabActive: {
      default: false,
      type: Boolean,
    },
    itemTitle: {
      default: '',
      type: String,
    },
    creatable: {
      type: Boolean,
      default: true
    },
    fussysortKeys: {
      type: Array,
      default() {
        return ['name']
      },
    },
    keyTitle: {
      type: String,
      default: 'name'
    }
  },
  data() {
    return {
      filter: '',
      selected: null,
      selectedIndex: null,
      listItemStart: 0,
    }
  },
  computed: {
    filteredItems() {
      if (!this.filter) {
        return this.items
      }
      return fuzzysort.go(this.filter, this.items, { keys: this.fussysortKeys })
        .map(item => item.obj)
    },
    items: {
      get() {
        return this.value
      },
      set() {
        this.$emit('input', this.value)
      }
    },
  },
  watch: {
    isTabActive(isActive) {
      if (isActive) {
        this.selected = null
        this.selectedIndex = null
        this.$refs.search.focus()
        this.$emit('onTabActive')
      }
    }
  },
  mounted() {
    if (process.client) {
      if (this.isTabActive === true) {
        this.$refs.search.focus()
      }
    }
  },
  methods: {
    onFilterItems() {
      if (!this.filter) {
        try {
          this.$refs.virtualList.forceRender()
        } catch (e) {}
      }
    },
    keyDown() {
      let index = this.selected
        ? this.selectedIndex
        : -1
      if (index === this.filteredItems.length - 1 || index === -1) {
        index = 0
        this.listItemStart = index
      } else {
        index += 1
      }
      this.selected = this.filteredItems[index]
      this.selectedIndex = index
      this.scrollIntoSelected()
    },
    keyUp() {
      let index = this.selected
        ? this.selectedIndex
        : -1
      if (index === -1 || index === 0) {
        index = this.filteredItems.length - 1
        this.listItemStart = index
      } else {
        index -= 1
      }
      this.selected = this.filteredItems[index]
      this.selectedIndex = index
      this.scrollIntoSelected()
    },
    scrollIntoSelected() {
      this.$nextTick(() => {
        try {
          $(this.$refs.component).find('.-sel')[0].scrollIntoView({ behavior: 'smooth', block: 'center' })
        } catch (e) {
          console.log(e)
        }
      })
    },
    keyEnter(e) {
      if (this.selected) {
        if (!e.ctrlKey) {
          this.$emit('leftClick', this.selected)
        } else {
          this.$emit('rightClick', this.selected)
        }
      }
    },
  },
}
</script>

<style lang="less">
@import "./TabSimple.less";
</style>